function setDirection(obj, x, y) {
    obj.direction['x'] = x;
    return obj.direction['y'] = y;
};
var TILESIZE = 64;
var TILESIZEGOOPOOL = 32;
var HEALTHPOINTWIDTH = 16;
var TILESIZESPELL = 24;
function partial(func) {
    var args1 = [];
    for (var i5068 = 0; i5068 < arguments.length - 1; i5068 += 1) {
        args1[i5068] = arguments[i5068 + 1];
    };
    return function () {
        var args2 = [];
        for (var i5069 = 0; i5069 < arguments.length - 0; i5069 += 1) {
            args2[i5069] = arguments[i5069 + 0];
        };
        return func.apply(this, args1.concat(args2));
    };
};
window.onload = init;
var bootState = { create : function (game) {
    game.physics.startSystem(Phaser.Physics.ARCADE);
    game.state.start('load');
    return null;
} };
function scaleGame() {
    game.scale.maxWidth = 1024;
    game.scale.maxHeight = 768;
    game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
    return game.scale.updateLayout();
};
var loadState = { preload : function (game) {
    game.load.spritesheet('player', 'assets/characters/cowboy.png', TILESIZE, TILESIZE);
    game.load.spritesheet('zombie-melee', 'assets/characters/zombie-melee.png', TILESIZE, TILESIZE);
    game.load.spritesheet('zombie-range', 'assets/characters/zombie-range.png', TILESIZE, TILESIZE);
    game.load.spritesheet('zombie-boss', 'assets/characters/zombie-boss.png', TILESIZE, TILESIZE);
    game.load.spritesheet('zombie-spawn', 'assets/characters/zombie-spawn.png', TILESIZE, TILESIZE);
    game.load.image('bullet', 'assets/characters/bullet.png');
    game.load.image('health-bar', 'assets/characters/health-bar.png');
    game.load.image('goo-pool', 'assets/characters/goo-pool.png');
    game.load.spritesheet('goo-pool-animated', 'assets/characters/goo-pool-animated-32.png', TILESIZEGOOPOOL, TILESIZEGOOPOOL);
    game.load.spritesheet('boss-cast-zombie', 'assets/characters/boss-cast-zombie.png', TILESIZESPELL, TILESIZESPELL);
    game.load.spritesheet('boss-projectile-animated', 'assets/characters/boss-projectile-animated.png', TILESIZESPELL, TILESIZESPELL);
    game.load.tilemap('prery', 'assets/maps/prery.json', null, Phaser.Tilemap.TILED_JSON);
    game.load.image('tiles-sand', 'assets/tiles/sand.png');
    game.load.spritesheet('chicken', 'assets/characters/chicken.png', TILESIZE, TILESIZE);
    game.load.spritesheet('master-gun', 'assets/characters/master-gun.png', TILESIZE, TILESIZE);
    game.load.audio('music', 'assets/sounds/music.ogg');
    game.load.audio('gunshot', 'assets/sounds/gunshot.ogg');
    game.load.audio('cowboy-hurt', 'assets/sounds/cowboy-hurt.ogg');
    game.load.audio('zombie-hurt', 'assets/sounds/zombie-hurt.ogg');
    game.load.audio('eat-chicken', 'assets/sounds/eat-chicken.ogg');
    game.load.audio('get-master-gun', 'assets/sounds/get-master-gun.ogg');
    return null;
}, create : function (game) {
    game.state.start('play');
    return null;
} };
var menuState = {  };
var GAMERESTARTTIMEOUT = 10000;
var PLAYERVELOCITY = 300;
var PLAYERVELOCITYDIAGONAL = PLAYERVELOCITY / 1.4142;
var PLAYERMAXHEALTH = 10;
var PLAYERFRAMERATE = 8;
var PLAYERMAXHEALTH = 10;
var GENERICGUNTYPE = 0;
var MASTERGUNTYPE = 1;
var MASTERGUNFRAMERATE = 8;
var MASTERGUNDELAY = 50;
var CHICKENLEGHP = 3;
var CHICKENLEGDROPRATE = 0.1;
var CHICKENLEGLIFETIME = 10000;
var CHICKENLEGFRAMERATE = 8;
var MELEEZOMBIEDESC = { type : 'zombie-melee',
                        hp : 200,
                        framerate : 8
                      };
var RANGEZOMBIEDESC = { type : 'zombie-range',
                        hp : 100,
                        framerate : 8
                      };
var BOSSZOMBIEDESC = { type : 'zombie-boss',
                       hp : 5000,
                       framerate : 8
                     };
var ZOMBIESTOPDISTANCE = 65;
var ZOMBIEMELEEWALKVELOCITY = 10;
var ZOMBIEMELEERUNVELOCITY = 120;
var ZOMBIEMELEERANGE = TILESIZE * 4;
var ZOMBIEMELEETURNINTERVAL = 2000;
var ZOMBIEMELEESTRENGTH = 3;
var ZOMBIEMELEEATTACKINTERVAL = 1000;
var ZOMBIEMELEEATTACKDISTANCE = 70;
var ZOMBIERANGEWALKVELOCITY = 8;
var ZOMBIERANGERUNVELOCITY = 20;
var ZOMBIERANGERANGE = TILESIZE * 5;
var ZOMBIERANGETURNINTERVAL = 3000;
var ZOMBIERANGESTRENGTH = 0;
var ZOMBIERANGEATTACKINTERVAL = 5000;
var ZOMBIERANGEATTACKDISTANCE = TILESIZE * 3;
var ZOMBIEBOSSWALKVELOCITY = 200;
var ZOMBIEBOSSRANGE = TILESIZE * 12;
var ZOMBIEBOSSTURNINTERVAL = 1000;
var ZOMBIEBOSSSPELLDAMAGE = 1;
var ZOMBIEBOSSSPELLDISTANCE = TILESIZE * 12;
var SPELLFRAMERATE = 8;
var ZOMBIEBOSSSPELLPROJECTILETIME = 1200;
var ZOMBIEBOSSSPELLPROJECTILEINTERVAL = 3000;
var ZOMBIEBOSSSPELLCASTZOMBIETIME = 1200;
var ZOMBIEBOSSSPELLCASTZOMBIEINTERVAL = 7000;
var TELEPORTINGRANGE = TILESIZE * 4;
var TELEPORTINGTIMEOUT = 100;
var ZOMBIEMELEERESPAWN = 20000;
var ZOMBIERANGERESPAWN = 30000;
var GOOPOOLFRAMERATE = 16;
var GOOPOOLLIVETIME = 3000;
var GOOPOOLDAMAGE = 1;
var GOOPOOLDAMAGEINTERVAL = 100;
var PROJECTILEFRAMERATE = 32;
var SPAWNFRAMERATE = 8;
var FIREINTERVAL = 500;
var LASTFIRE = 0;
var BULLETVELOCITY = 500;
var BULLETDAMAGE = 50;
var FIRETIME = 50;
var TINTTIME = 100;
var HITTIME = 100;
var GAMEOVER = 1;
var WIN = 2;
var PLAYING = 3;
var AUDIOS = this;
function playerMoveDown(player) {
    player.body.velocity.y = PLAYERVELOCITY;
    player.animations.play('down', null, null, null);
    setDirection(player, 0, 1);
    player.directionFrame = 0;
    player.fireFrame = 4;
    return null;
};
function playerMoveUp(player) {
    player.body.velocity.y = -PLAYERVELOCITY;
    player.animations.play('up', null, null, null);
    setDirection(player, 0, -1);
    player.directionFrame = 5;
    player.fireFrame = 9;
    return null;
};
function playerMoveRight(player) {
    player.body.velocity.x = PLAYERVELOCITY;
    player.animations.play('right', null, null, null);
    setDirection(player, 1, 0);
    player.directionFrame = 10;
    player.fireFrame = 14;
    return null;
};
function playerMoveLeft(player) {
    player.body.velocity.x = -PLAYERVELOCITY;
    player.animations.play('left', null, null, null);
    setDirection(player, -1, 0);
    player.directionFrame = 15;
    player.fireFrame = 19;
    return null;
};
function playerMoveUpRight(player) {
    playerMoveRight(player);
    player.body.velocity.y = -PLAYERVELOCITYDIAGONAL;
    player.body.velocity.x = PLAYERVELOCITYDIAGONAL;
    return null;
};
function playerMoveDownRight(player) {
    playerMoveRight(player);
    player.body.velocity.y = PLAYERVELOCITYDIAGONAL;
    player.body.velocity.x = PLAYERVELOCITYDIAGONAL;
    return null;
};
function playerMoveUpLeft(player) {
    playerMoveLeft(player);
    player.body.velocity.y = -PLAYERVELOCITYDIAGONAL;
    player.body.velocity.x = -PLAYERVELOCITYDIAGONAL;
    return null;
};
function playerMoveDownLeft(player) {
    playerMoveLeft(player);
    player.body.velocity.y = PLAYERVELOCITYDIAGONAL;
    player.body.velocity.x = -PLAYERVELOCITYDIAGONAL;
    return null;
};
function playerStop(player) {
    if (!player.animations.paused) {
        player.animations.stop(null, true);
        player.frame = player.directionFrame;
    };
    return null;
};
function killZombie(game, zombie, zombieGroup, bottomGroup, killFn) {
    var zombieSpawn = zombie.spawn;
    zombieGroup.remove(zombie);
    bottomGroup.add(zombie);
    zombie.killed = true;
    zombie.body = false;
    zombie.spawn.zombie = null;
    zombie.spawn.zombieKilledTime = (new Date()).getTime();
    zombie.spawn = null;
    zombie.animations.play('die', null, null, null);
    var dieAnimation = zombie.animations.getAnimation('die');
    dieAnimation.onComplete.add(function (sprite, animation) {
        if (Math.random() < CHICKENLEGDROPRATE) {
            var chickenLeg = game.medicine.create(zombie.x, zombie.y, 'chicken');
            chickenLeg.createTime = (new Date()).getTime();
            chickenLeg.animations.add('being', [0, 1, 2, 1, 0, 3, 4, 3], 8, true);
            chickenLeg.animations.play('being', null, null, null);
        };
        zombie.destroy();
        if (killFn) {
            killFn(zombie, zombieSpawn);
        };
        return null;
    }, this);
    return null;
};
function bulletHitEnemy(game, bullet, enemy, zombieGroup, bottomGroup, killFn) {
    bullet.kill();
    AUDIOS.zombieHurt.play();
    var currentHp = enemy.hp;
    var newHp = currentHp - BULLETDAMAGE;
    if (newHp <= 0) {
        killZombie(game, enemy, zombieGroup, bottomGroup, killFn);
    } else {
        enemy.animations.stop(null, true);
        enemy.frame = 24;
        enemy.lastHitTime = (new Date()).getTime();
        enemy.hp = newHp;
        var onHit5070 = enemy.onHit;
        if (onHit5070) {
            enemy.onHit(game, enemy);
        };
    };
    return null;
};
function bulletHitWall(bullet, wall) {
    bullet.kill();
    return null;
};
function fireBullet(player, bullets) {
    player.animations.stop(null, true);
    AUDIOS.gunshot.play();
    var bullet = bullets.getFirstDead();
    bullet.reset(player.x + player.width / 2, player.y + player.height / 2);
    bullet.body.velocity.x = BULLETVELOCITY * player.direction.x;
    bullet.body.velocity.y = BULLETVELOCITY * player.direction.y;
    return bullet.angle = player.direction.x === 1 ? 0 : (player.direction.y === 1 ? 90 : (player.direction.x === -1 ? 180 : (player.direction.y === -1 ? 270 : null)));
};
function fire(game, player, bullets) {
    if (0 < bullets.countDead()) {
        LASTFIRE = game.time.now;
        player.fireState = true;
        player.lastFireTime = (new Date()).getTime();
        fireBullet(player, bullets);
        if (player.gunType === MASTERGUNTYPE) {
            setTimeout(function () {
                return fireBullet(player, bullets);
            }, MASTERGUNDELAY);
        };
    };
    return null;
};
function square(x) {
    return x * x;
};
function distanceSquare(obj1, obj2) {
    return square(obj2.x - obj1.x) + square(obj2.y - obj1.y);
};
function gameOver(game) {
    game.gameState = GAMEOVER;
    var x = game.width / 2 - 90;
    var y = game.height / 2 - 40;
    var text5071 = game.add.text(x, y, 'GAME OVER', { font : '32px Arial',
                                                      fill : '#FF0000',
                                                      align : 'center'
                                                    });
    text5071.fixedToCamera = true;
    var x5072 = game.width / 2 - 110;
    var y5073 = game.height / 2 - 0;
    var text5074 = game.add.text(x5072, y5073, 'press R to play again', { font : '24px Arial',
                                                                          fill : '#FF0000',
                                                                          align : 'center'
                                                                        });
    return text5074.fixedToCamera = true;
};
function winWinWin(game) {
    game.gameState = WIN;
    var x = game.width / 2 - 200;
    var y = game.height / 2 - 40;
    var text5075 = game.add.text(x, y, 'Congratulations! You\'ve won!', { font : '32px Arial',
                                                                          fill : '#00FF00',
                                                                          align : 'center'
                                                                        });
    text5075.fixedToCamera = true;
    var x5076 = game.width / 2 - 110;
    var y5077 = game.height / 2 - 0;
    var text5078 = game.add.text(x5076, y5077, 'press R to play again', { font : '24px Arial',
                                                                          fill : '#00FF00',
                                                                          align : 'center'
                                                                        });
    return text5078.fixedToCamera = true;
};
function setPlayerHealth(player, health) {
    player.health = health;
    player.healthBar.cropRect.width = health * HEALTHPOINTWIDTH;
    return player.healthBar.updateCrop();
};
function hitPlayer(game, player, damage) {
    AUDIOS.cowboyHurt.play();
    if (!player.hitState) {
        player.hitState = true;
        player.lastHitTime = (new Date()).getTime();
    };
    var health5079 = Math.max(player.health - damage, 0);
    setPlayerHealth(player, health5079);
    if (0 === health5079) {
        player.body = null;
        player.animations.play('die', null, null, null);
        gameOver(game);
    };
    return null;
};
function zombieMeleeAttack(game, zombie, player) {
    var lastAttack5080 = zombie.lastAttack;
    var gameTime = game.time.now;
    if (lastAttack5080 + ZOMBIEMELEEATTACKINTERVAL < gameTime) {
        zombie.lastAttack = gameTime;
        return hitPlayer(game, player, ZOMBIEMELEESTRENGTH);
    };
};
function zombieMeleePatrol(game, zombie) {
    if (zombie.lastTurnTime + ZOMBIEMELEETURNINTERVAL < game.time.now) {
        zombie.lastTurnTime = game.time.now;
        var direction = Math.floor(4 * Math.random());
        var zombieVelocity = ZOMBIEMELEEWALKVELOCITY;
        zombie.body.velocity.x = ZOMBIEMELEEWALKVELOCITY * (direction === 0 ? 1 : (direction === 1 ? -1 : (true ? 0 : null)));
        zombie.body.velocity.y = ZOMBIEMELEEWALKVELOCITY * (direction === 2 ? 1 : (direction === 3 ? -1 : (true ? 0 : null)));
        if (direction === 0) {
            return 0;
        } else if (direction === 1) {
            return 3.14;
        } else if (direction === 2) {
            return 1.57;
        } else if (direction === 3) {
            return -1.57;
        };
    };
};
function zombieStop(zombie) {
    zombie.body.velocity.x = 0;
    return zombie.body.velocity.y = 0;
};
function updateZombieMelee(game, zombie, player) {
    if (!zombie.busy && !zombie.killed && (new Date()).getTime() - zombie.lastHitTime > HITTIME) {
        var distanceSquared = distanceSquare(zombie, player);
        var attack = Math.abs(zombie.x - player.x) < ZOMBIEMELEEATTACKDISTANCE && Math.abs(zombie.y - player.y) < ZOMBIEMELEEATTACKDISTANCE;
        var playerDetected = distanceSquared < square(ZOMBIEMELEERANGE);
        var velocity = attack ? 0 : (playerDetected ? ZOMBIEMELEERUNVELOCITY : (true ? ZOMBIEMELEEWALKVELOCITY : null));
        var angle = playerDetected ? game.physics.arcade.moveToObject(zombie, player, velocity) : zombieMeleePatrol(game, zombie);
        var direction = angle < -2.36 || angle >= 2.36 ? 'left' : (angle < -0.79 ? 'up' : (angle < 0.79 ? 'right' : (true ? 'down' : null)));
        var animation = attack ? direction + '-attack' : direction;
        if (attack) {
            var attackAnimation = zombie.animations.play(animation, null, null, null);
            zombieStop(zombie);
            attackAnimation.onComplete.add(function () {
                zombieMeleeAttack(game, zombie, player);
                return zombie.busy = false;
            }, null);
            return zombie.busy = true;
        } else {
            return angle != null ? zombie.animations.play(animation, null, null, null) : null;
        };
    };
};
function updateZombiesMelee(game, zombies, player) {
    var _js5081 = zombies.children;
    var _js5083 = _js5081.length;
    for (var _js5082 = 0; _js5082 < _js5083; _js5082 += 1) {
        var zombie = _js5081[_js5082];
        updateZombieMelee(game, zombie, player);
    };
};
function gooPoolHitPlayer(game, player, gooPool) {
    if (gooPool.alive) {
        var lastDamage5084 = gooPool.lastDamage;
        var gameTime = game.time.now;
        if (lastDamage5084 + GOOPOOLDAMAGEINTERVAL < gameTime) {
            gooPool.lastDamage = gameTime;
            return hitPlayer(game, player, (GOOPOOLDAMAGE * GOOPOOLDAMAGEINTERVAL) / 1000);
        };
    };
};
function updateGooPools(game, gooPools) {
    var gameTime = game.time.now;
    var _js5085 = gooPools.children;
    var _js5087 = _js5085.length;
    for (var _js5086 = 0; _js5086 < _js5087; _js5086 += 1) {
        var gooPool = _js5085[_js5086];
        if (gooPool.alive && gooPool.creationTime + GOOPOOLLIVETIME < gameTime) {
            gooPool.kill();
        };
    };
};
function placeGooPool(game, gooPool, x, y) {
    gooPool.reset(x, y);
    return gooPool.creationTime = game.time.now;
};
function zombieRangeSpellGooPool(game, zombie, player, gooPool) {
    var spell = game.add.sprite(zombie.x + 20, zombie.y + 0, 'goo-pool-animated');
    var spellAnimation = spell.animations.add('spell', [10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0], GOOPOOLFRAMERATE, false);
    var distance = game.physics.arcade.distanceBetween(zombie, player);
    var velocity = distance / (11 / GOOPOOLFRAMERATE);
    var destinationX = player.x + player.width / 2;
    var destinationY = player.y + player.height / 2;
    spellAnimation.onComplete.add(function () {
        return placeGooPool(game, gooPool, destinationX, destinationY);
    }, null);
    game.physics.arcade.enable(spell);
    spell.animations.play('spell', null, false, true);
    return game.physics.arcade.moveToXY(spell, player.x + 16, player.y + 16, velocity);
};
function fireGooPool(game, zombie, player, gooPools) {
    var gooPool = gooPools.getFirstDead();
    return gooPool ? zombieRangeSpellGooPool(game, zombie, player, gooPool) : null;
};
function zombieRangeAttack(game, zombie, player, gooPools) {
    var lastAttack5088 = zombie.lastAttack;
    var gameTime = game.time.now;
    if (lastAttack5088 + ZOMBIERANGEATTACKINTERVAL < gameTime) {
        zombie.lastAttack = gameTime;
        return fireGooPool(game, zombie, player, gooPools);
    };
};
function zombieRangeAttackReadywhat(game, zombie) {
    var lastAttack5089 = zombie.lastAttack;
    var gameTime = game.time.now;
    return lastAttack5089 + ZOMBIERANGEATTACKINTERVAL < gameTime;
};
function zombieRangePatrol(game, zombie) {
    if (zombie.lastTurnTime + ZOMBIERANGETURNINTERVAL < game.time.now) {
        zombie.lastTurnTime = game.time.now;
        var direction = Math.floor(4 * Math.random());
        var zombieVelocity = ZOMBIERANGEWALKVELOCITY;
        zombie.body.velocity.x = ZOMBIERANGEWALKVELOCITY * (direction === 0 ? 1 : (direction === 1 ? -1 : (true ? 0 : null)));
        zombie.body.velocity.y = ZOMBIERANGEWALKVELOCITY * (direction === 2 ? 1 : (direction === 3 ? -1 : (true ? 0 : null)));
        if (direction === 0) {
            return 0;
        } else if (direction === 1) {
            return 3.14;
        } else if (direction === 2) {
            return 1.57;
        } else if (direction === 3) {
            return -1.57;
        };
    };
};
function updateZombieRange(game, zombie, player, gooPools) {
    if (!zombie.busy && !zombie.killed && (new Date()).getTime() - zombie.lastHitTime > HITTIME) {
        var distanceSquared = distanceSquare(zombie, player);
        var stopMove = Math.abs(zombie.x - player.x) < ZOMBIESTOPDISTANCE && Math.abs(zombie.y - player.y) < ZOMBIESTOPDISTANCE;
        var attackReady = zombieRangeAttackReadywhat(game, zombie);
        var attack = attackReady && distanceSquared < square(ZOMBIERANGEATTACKDISTANCE);
        var playerDetected = distanceSquared < square(ZOMBIERANGERANGE);
        var velocity = stopMove ? 0 : (attack ? 0 : (playerDetected ? ZOMBIERANGERUNVELOCITY : (true ? ZOMBIERANGEWALKVELOCITY : null)));
        var angle = stopMove ? zombieStop(zombie) : (playerDetected && attackReady ? game.physics.arcade.moveToObject(zombie, player, velocity) : (true ? zombieRangePatrol(game, zombie) : null));
        var direction = angle < -2.36 || angle >= 2.36 ? 'left' : (angle < -0.79 ? 'up' : (angle < 0.79 ? 'right' : (true ? 'down' : null)));
        var animation = attack ? direction + '-attack' : direction;
        if (attack) {
            var attackAnimation = zombie.animations.play(animation, null, null, null);
            attackAnimation.onComplete.add(function () {
                zombieRangeAttack(game, zombie, player, gooPools);
                return zombie.busy = false;
            }, null);
            return zombie.busy = true;
        } else {
            return angle != null ? zombie.animations.play(animation, null, null, null) : null;
        };
    };
};
function updateZombiesRange(game, zombies, player, gooPools) {
    var _js5090 = zombies.children;
    var _js5092 = _js5090.length;
    for (var _js5091 = 0; _js5091 < _js5092; _js5091 += 1) {
        var zombie = _js5090[_js5091];
        updateZombieRange(game, zombie, player, gooPools);
    };
};
function stopAttack(game, obj) {
    obj.busy = false;
    return obj.lastAttack = game.time.now;
};
function zombieBossStopSpell(game, zombie) {
    if (zombie.spelling) {
        zombie.spell.animations.stop(null, true);
        zombie.spell.destroy();
        return zombie.spelling = false;
    };
};
function zombieBossTeleport(game, zombie) {
    zombie.x = zombie.originX + Math.floor(TELEPORTINGRANGE * 2 * Math.random()) + -TELEPORTINGRANGE;
    return zombie.y = zombie.originY + Math.floor(TELEPORTINGRANGE * 2 * Math.random()) + -TELEPORTINGRANGE;
};
function zombieBossStartTeleport(game, zombie) {
    if (zombie.teleportStart) {
        clearTimeout(zombie.teleportStart);
        zombie.teleportStart = null;
        return zombieBossTeleport(game, zombie);
    } else {
        return zombie.teleportStart = setTimeout(function () {
            return zombieBossTeleport(game, zombie);
        }, TELEPORTINGTIMEOUT);
    };
};
function onZombieBossHit(game, zombie) {
    stopAttack(game, zombie);
    if (zombie.stopAttack) {
        zombie.stopAttack(game, zombie);
    };
    if (zombie.zombieType === 'zombie-boss') {
        zombieBossStopSpell(game, zombie);
        return zombieBossStartTeleport(game, zombie);
    };
};
function blowUpProjectile(game, player, x, y) {
    return hitPlayer(game, player, ZOMBIEBOSSSPELLDAMAGE);
};
function zombieBossProjectile(game, zombie, player) {
    zombie.lastProjectile = game.time.now;
    var spell = game.add.sprite(zombie.x + 20, zombie.y + 0, 'boss-projectile-animated');
    var spellAnimation = spell.animations.add('spell', [7, 6, 5, 4, 3, 2, 1, 0], PROJECTILEFRAMERATE, false);
    var distance = game.physics.arcade.distanceBetween(zombie, player);
    var velocity = distance / (8 / PROJECTILEFRAMERATE);
    var destinationX = player.x + player.width / 2;
    var destinationY = player.y + player.height / 2;
    spellAnimation.onComplete.add(function () {
        return blowUpProjectile(game, player, destinationX, destinationY);
    }, null);
    game.physics.arcade.enable(spell);
    spell.animations.play('spell', null, false, true);
    return game.physics.arcade.moveToXY(spell, player.x + 20, player.y + 20, velocity);
};
function zombieBossSpellProjectile(game, animation, zombie, player) {
    var gameTime = game.time.now;
    var spellStart5093 = zombie.spellStart;
    if (spellStart5093 + ZOMBIEBOSSSPELLPROJECTILETIME <= gameTime) {
        zombieBossStopSpell(game, zombie);
        return zombieBossProjectile(game, zombie, player);
    } else {
        return animation.play();
    };
};
function zombieBossStartSpellProjectile(game, zombie, player, animationName) {
    var zombieAnimation = zombie.animations.play(animationName, null, null, null);
    zombieAnimation.onComplete.removeAll();
    zombieAnimation.onComplete.add(function () {
        return zombieBossSpellProjectile(game, zombieAnimation, zombie, player);
    }, null);
    zombie.spellStart = game.time.now;
    zombie.spelling = true;
    zombie.stopAttack = function (game, zombie) {
        return zombie.lastProjectile = game.time.now;
    };
    var spell = game.add.sprite(zombie.x - 8, zombie.y - 12, 'boss-projectile-animated');
    var spellAnimation = spell.animations.add('spell', [7, 6, 5, 4, 3, 2, 1, 0], SPELLFRAMERATE, false);
    zombie.spell = spell;
    return spell.animations.play('spell', null, true, false);
};
function zombieBossSpellProjectileReadywhat(game, zombie) {
    var lastProjectile5094 = zombie.lastProjectile;
    var gameTime = game.time.now;
    return lastProjectile5094 + ZOMBIEBOSSSPELLPROJECTILEINTERVAL < gameTime;
};
function zombieBossCastZombie(game, zombie, player) {
    zombie.lastCastZombie = game.time.now;
    var zombieType = Math.floor(2 * Math.random());
    var zombiesGroup = zombieType === 0 ? game.zombiesMelee : game.zombiesRange;
    var zombiesDesc = zombieType === 0 ? MELEEZOMBIEDESC : RANGEZOMBIEDESC;
    var spawn = createSpawn(((zombie.x + player.x) / TILESIZE) / 2, ((zombie.y + player.y) / TILESIZE) / 2, zombiesGroup, 10000, zombiesDesc);
    return spawnZombie(game, spawn);
};
function zombieBossSpellCastZombie(game, animation, zombie, player) {
    var gameTime = game.time.now;
    var spellStart5095 = zombie.spellStart;
    if (spellStart5095 + ZOMBIEBOSSSPELLCASTZOMBIETIME <= gameTime) {
        zombieBossStopSpell(game, zombie);
        return zombieBossCastZombie(game, zombie, player);
    } else {
        return animation.play();
    };
};
function zombieBossStartSpellCastZombie(game, zombie, player, animationName) {
    var zombieAnimation = zombie.animations.play(animationName, null, null, null);
    zombieAnimation.onComplete.removeAll();
    zombieAnimation.onComplete.add(function () {
        return zombieBossSpellCastZombie(game, zombieAnimation, zombie, player);
    }, null);
    zombie.spellStart = game.time.now;
    zombie.spelling = true;
    zombie.stopAttack = function (game, zombie) {
        return zombie.lastCastZombie = game.time.now;
    };
    var spell = game.add.sprite(zombie.x - 8, zombie.y - 12, 'boss-cast-zombie');
    var spellAnimation = spell.animations.add('spell', [0, 1, 2, 3], SPELLFRAMERATE, false);
    zombie.spell = spell;
    return spell.animations.play('spell', null, true, false);
};
function zombieBossSpellCastZombieReadywhat(game, zombie) {
    var lastCastZombie5096 = zombie.lastCastZombie;
    var gameTime = game.time.now;
    return lastCastZombie5096 + ZOMBIEBOSSSPELLCASTZOMBIEINTERVAL < gameTime;
};
function zombieBossPatrol(game, zombie) {
    if (zombie.lastTurnTime + ZOMBIEBOSSTURNINTERVAL < game.time.now) {
        zombie.lastTurnTime = game.time.now;
        var direction = Math.floor(4 * Math.random());
        var zombieVelocity = ZOMBIEBOSSWALKVELOCITY;
        zombie.body.velocity.x = ZOMBIEBOSSWALKVELOCITY * (direction === 0 ? 1 : (direction === 1 ? -1 : (true ? 0 : null)));
        zombie.body.velocity.y = ZOMBIEBOSSWALKVELOCITY * (direction === 2 ? 1 : (direction === 3 ? -1 : (true ? 0 : null)));
        if (direction === 0) {
            return 0;
        } else if (direction === 1) {
            return 3.14;
        } else if (direction === 2) {
            return 1.57;
        } else if (direction === 3) {
            return -1.57;
        };
    };
};
function zombieBossStop(game, zombie) {
    zombie.body.velocity.x = 0;
    zombie.body.velocity.y = 0;
    return 1.57;
};
function updateZombieBoss(game, zombie, player) {
    if (!zombie.spelling && !zombie.killed && (new Date()).getTime() - zombie.lastHitTime > HITTIME) {
        var distanceSquared = distanceSquare(zombie, player);
        var stopMove = Math.abs(zombie.x - player.x) < ZOMBIESTOPDISTANCE && Math.abs(zombie.y - player.y) < ZOMBIESTOPDISTANCE;
        var projectileReady = zombieBossSpellProjectileReadywhat(game, zombie);
        var castZombieReady = zombieBossSpellCastZombieReadywhat(game, zombie);
        var attack = (projectileReady || castZombieReady) && distanceSquared < square(ZOMBIEBOSSSPELLDISTANCE);
        var playerDetected = distanceSquared < square(ZOMBIEBOSSRANGE);
        var velocity = attack ? 0 : (playerDetected ? ZOMBIEBOSSWALKVELOCITY : (true ? 0 : null));
        var angle = playerDetected && !attack && !stopMove ? zombieBossPatrol(game, zombie) : zombieBossStop(game, zombie);
        var direction = angle < -2.36 || angle >= 2.36 ? 'left' : (angle < -0.79 ? 'up' : (angle < 0.79 ? 'right' : (true ? 'down' : null)));
        var animation = attack ? direction + '-attack' : direction;
        if (projectileReady) {
            return zombieBossStartSpellProjectile(game, zombie, player, animation);
        } else if (castZombieReady) {
            return zombieBossStartSpellCastZombie(game, zombie, player, animation);
        } else if (true) {
            return angle != null ? zombie.animations.play(animation, null, null, null) : null;
        };
    };
};
function updateZombiesBoss(game, zombies, player) {
    var _js5097 = zombies.children;
    var _js5099 = _js5097.length;
    for (var _js5098 = 0; _js5098 < _js5099; _js5098 += 1) {
        var zombie = _js5097[_js5098];
        updateZombieBoss(game, zombie, player);
    };
};
function updatePlayer(player) {
    var cur = (new Date()).getTime();
    var timeDiff = cur - player.lastHitTime;
    var fireDiff = cur - player.lastFireTime;
    if (player.hitState) {
        if (timeDiff < TINTTIME) {
            player.tint = 0xff00ff;
        } else if (timeDiff < 2 * TINTTIME) {
            player.tint = player.currentTint;
        } else {
            player.hitState = false;
        };
    };
    if (player.fireState) {
        if (fireDiff < FIRETIME) {
            player.frame = player.fireFrame;
        } else {
            player.fireState = false;
            player.frame = player.directionFrame;
        };
    };
    return null;
};
function spawnZombie(game, spawn) {
    var x5100 = spawn.x;
    var y5101 = spawn.y;
    var zombieSpawn = game.add.sprite(TILESIZE * x5100, TILESIZE * y5101, 'zombie-spawn');
    var beginAnimation = zombieSpawn.animations.add('begin', [0, 1, 2, 3, 4], SPAWNFRAMERATE, false);
    var endAnimation = zombieSpawn.animations.add('end', [5, 6, 7, 8, 9], SPAWNFRAMERATE, false);
    zombieSpawn.animations.play('begin', null, null, null);
    beginAnimation.onComplete.add(function (sprite, animation) {
        var zombieDesc5102 = spawn.zombieDesc;
        var type5103 = zombieDesc5102.type;
        var framerate5104 = zombieDesc5102.framerate;
        var group5105 = spawn.group;
        var zombie = group5105.create(TILESIZE * x5100, TILESIZE * y5101, type5103);
        zombie.animations.add('down', [1, 2, 3, 2], framerate5104, true);
        zombie.animations.add('down-attack', [4, 5], framerate5104, false);
        zombie.animations.add('up', [7, 8, 9, 8], framerate5104, true);
        zombie.animations.add('up-attack', [10, 11], framerate5104, false);
        zombie.animations.add('right', [13, 14, 15, 14], framerate5104, true);
        zombie.animations.add('right-attack', [16, 17], framerate5104, false);
        zombie.animations.add('left', [19, 20, 21, 20], framerate5104, true);
        zombie.animations.add('left-attack', [22, 23], framerate5104, false);
        zombie.animations.add('die', [25, 26, 27, 28, 29, 30, 31, 32, 34], framerate5104, false);
        zombie.body.immovable = true;
        zombie.killed = false;
        zombie.hp = zombieDesc5102.hp;
        zombie.lastTurnTime = 0;
        zombie.spawn = spawn;
        spawn.zombie = zombie;
        zombie.lastAttack = 0;
        zombie.lastProjectile = 0;
        zombie.lastCastZombie = 0;
        zombie.lastHitTime = 0;
        zombie.zombieType = type5103;
        zombie.onHit = onZombieBossHit;
        zombie.originX = zombie.x;
        zombie.originY = zombie.y;
        zombieSpawn.animations.play('end', null, null, null);
        endAnimation.onComplete.add(function (endSprite, endAnimation) {
            endSprite.destroy();
            return null;
        }, this);
        return null;
    }, this);
    spawn.zombie = 'in-progess';
    return null;
};
function createSpawn(x, y, group, respawnTime, zombieDesc) {
    return { x : x,
             y : y,
             group : group,
             respawnTime : respawnTime,
             zombieDesc : zombieDesc,
             zombie : null,
             zombieKilledTime : 0
           };
};
function updateSpawn(game, spawn) {
    if (Phaser.Rectangle.containsPoint(game.camera.view, new Phaser.Point(TILESIZE * spawn.x, TILESIZE * spawn.y))) {
        var respawnTime5106 = spawn.respawnTime;
        var zombie5107 = spawn.zombie;
        var zombieKilledTime5108 = spawn.zombieKilledTime;
        var now = (new Date()).getTime();
        if (respawnTime5106 && zombie5107 === null && now - zombieKilledTime5108 > respawnTime5106) {
            spawnZombie(game, spawn);
        };
        return null;
    };
};
function createAmmunation(game, count, key, frame) {
    var ammunation = game.add.group();
    ammunation.enableBody = true;
    ammunation.physicsBodyType = Phaser.Physics.ARCADE;
    ammunation.createMultiple(count, key, frame);
    ammunation.setAll('anchor.x', 0.5);
    ammunation.setAll('anchor.y', 0.5);
    ammunation.setAll('outOfBoundsKill', true);
    ammunation.setAll('checkWorldBounds', true);
    return ammunation;
};
function takeMedicine(game, player, chickenLeg) {
    chickenLeg.destroy();
    var possibleHp = player.health + CHICKENLEGHP;
    var newHp = possibleHp > PLAYERMAXHEALTH ? PLAYERMAXHEALTH : possibleHp;
    setPlayerHealth(player, newHp);
    AUDIOS.eatChicken.play();
    return null;
};
function updateMedicine(chickenLeg) {
    if (chickenLeg) {
        var curTime = (new Date()).getTime();
        var createTime5109 = chickenLeg.createTime;
        if (curTime - createTime5109 > CHICKENLEGLIFETIME) {
            chickenLeg.destroy();
        };
    };
    return null;
};
function addMasterGun(masterGuns, x, y) {
    var masterGun = masterGuns.create(x, y, 'master-gun');
    masterGun.animations.add('being', [0, 1, 2, 1, 0, 3, 4, 3], MASTERGUNFRAMERATE, true);
    masterGun.animations.play('being', null, null, null);
    return null;
};
function takeMasterGun(player, masterGun) {
    masterGun.destroy();
    player.tint = 0xa0ffff;
    player.currentTint = 0xa0ffff;
    player.gunType = MASTERGUNTYPE;
    AUDIOS.getMasterGun.play();
    return null;
};
var playState = { player : null,
                  cursors : null,
                  layer : null,
                  zombiesMelee : null,
                  zombiesRange : null,
                  zombiesBoss : null,
                  bullets : null,
                  gooPools : null,
                  bottomObjs : null,
                  medicine : null,
                  masterGuns : null,
                  spawns : [],
                  create : function (game) {
    if (!AUDIOS.music) {
        AUDIOS.music = game.add.audio('music', 0.1, true);
        AUDIOS.music.play();
    };
    if (!AUDIOS.gunshot) {
        AUDIOS.gunshot = game.add.audio('gunshot', 1, null);
    };
    if (!AUDIOS.cowboyHurt) {
        AUDIOS.cowboyHurt = game.add.audio('cowboy-hurt', 1, null);
    };
    if (!AUDIOS.zombieHurt) {
        AUDIOS.zombieHurt = game.add.audio('zombie-hurt', 1, null);
    };
    if (!AUDIOS.eatChicken) {
        AUDIOS.eatChicken = game.add.audio('eat-chicken', 1, null);
    };
    if (!AUDIOS.getMasterGun) {
        AUDIOS.getMasterGun = game.add.audio('get-master-gun', 1, null);
    };
    var map = game.add.tilemap('prery');
    var mapWidth = map.width;
    var mapHeight = map.height;
    map.addTilesetImage('sand', 'tiles-sand');
    this.layer = map.createLayer('layer');
    map.setCollision([6, 7, 8, 9, 10, 11], true, this.layer);
    this.layer.resizeWorld();
    this.gooPools = createAmmunation(game, 30, 'goo-pool');
    this.bottomObjs = game.add.physicsGroup();
    this.medicine = game.add.physicsGroup();
    game.medicine = this.medicine;
    this.masterGuns = game.add.physicsGroup();
    game.masterGuns = this.masterGuns;
    this.zombiesMelee = game.add.physicsGroup();
    game.zombiesMelee = this.zombiesMelee;
    this.zombiesRange = game.add.physicsGroup();
    game.zombiesRange = this.zombiesRange;
    this.zombiesBoss = game.add.physicsGroup();
    var spawnLayer = map.createLayer('spawns');
    var _js5110 = spawnLayer.getTiles(0, 0, mapWidth * TILESIZE, mapHeight * TILESIZE);
    var _js5112 = _js5110.length;
    for (var _js5111 = 0; _js5111 < _js5112; _js5111 += 1) {
        var tile = _js5110[_js5111];
        if (tile.properties.spawn === 'cowboy') {
            this.player = game.add.sprite(TILESIZE * tile.x, TILESIZE * tile.y, 'player');
            this.player.health = PLAYERMAXHEALTH;
            var healthBar = game.add.sprite(32, 32, 'health-bar');
            var cropRect = new Phaser.Rectangle(0, 0, healthBar.width, healthBar.height);
            healthBar.fixedToCamera = true;
            healthBar.cropEnabled = true;
            this.player.healthBar = healthBar;
            this.player.healthBar.cropRect = cropRect;
            setPlayerHealth(this.player, PLAYERMAXHEALTH);
            this.player.fireState = false;
            this.player.lastFireTime = 0;
            this.player.direction = { x : 0, y : 1 };
            this.player.hitState = false;
            this.player.lastHitTime = 0;
            this.player.directionFrame = 0;
            this.player.fireFrame = 4;
            this.player.currentTint = 0xffffff;
            this.player.gunType = GENERICGUNTYPE;
            game.physics.arcade.enable(this.player);
            this.player.body.collideWorldBounds = true;
            this.player.animations.add('down', [1, 2, 3, 2], PLAYERFRAMERATE, true);
            this.player.animations.add('up', [6, 7, 8, 7], PLAYERFRAMERATE, true);
            this.player.animations.add('right', [11, 12, 13, 12], PLAYERFRAMERATE, true);
            this.player.animations.add('left', [16, 17, 18, 17], PLAYERFRAMERATE, true);
            this.player.animations.add('die', [20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31], PLAYERFRAMERATE, false);
            this.player.animations.play('down', null, null, null);
            game.camera.focusOnXY(TILESIZE * tile.x, TILESIZE * tile.y);
            game.camera.follow(this.player);
        } else if (tile.properties.spawn === 'master-gun') {
            addMasterGun(this.masterGuns, TILESIZE * tile.x, TILESIZE * tile.y);
        } else if (tile.properties.spawn === 'zombie-melee') {
            this.spawns.push(createSpawn(tile.x, tile.y, this.zombiesMelee, ZOMBIEMELEERESPAWN, MELEEZOMBIEDESC));
        } else if (tile.properties.spawn === 'zombie-range') {
            this.spawns.push(createSpawn(tile.x, tile.y, this.zombiesRange, ZOMBIERANGERESPAWN, RANGEZOMBIEDESC));
        } else if (tile.properties.spawn === 'zombie-boss') {
            this.spawns.push(createSpawn(tile.x, tile.y, this.zombiesBoss, 10000, BOSSZOMBIEDESC));
        } else {
        };
    };
    spawnLayer.destroy();
    this.bullets = createAmmunation(game, 30, 'bullet');
    var _js5113 = this.gooPools.children;
    var _js5115 = _js5113.length;
    for (var _js5114 = 0; _js5114 < _js5115; _js5114 += 1) {
        var gooPool = _js5113[_js5114];
        gooPool.lastDamage = 0;
    };
    this.cursors = game.input.keyboard.createCursorKeys();
    var key = game.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
    var player5116 = this.player;
    var bullets5117 = this.bullets;
    key.onDown.add(function () {
        return game.gameState === PLAYING ? fire(game, player5116, bullets5117) : null;
    });
    var key5118 = game.input.keyboard.addKey(Phaser.Keyboard.R);
    key5118.onDown.add(function () {
        return game.gameState !== PLAYING ? game.state.start('play') : null;
    });
    game.gameState = PLAYING;
    return null;
},
                  update : function (game) {
    game.physics.arcade.collide(this.player, this.layer, null);
    game.physics.arcade.collide(this.player, this.zombiesMelee, null);
    game.physics.arcade.collide(this.player, this.zombiesRange, null);
    game.physics.arcade.collide(this.player, this.zombiesBoss, null);
    game.physics.arcade.collide(this.zombiesMelee, this.layer, null);
    game.physics.arcade.collide(this.zombiesRange, this.layer, null);
    game.physics.arcade.collide(this.zombiesBoss, this.layer, null);
    game.physics.arcade.collide(this.zombiesMelee, this.zombiesMelee, null);
    game.physics.arcade.collide(this.zombiesMelee, this.zombiesRange, null);
    game.physics.arcade.collide(this.zombiesMelee, this.zombiesBoss, null);
    game.physics.arcade.collide(this.zombiesRange, this.zombiesRange, null);
    game.physics.arcade.collide(this.zombiesRange, this.zombiesBoss, null);
    game.physics.arcade.collide(this.zombiesBoss, this.zombiesBoss, null);
    game.physics.arcade.collide(this.bullets, this.layer, bulletHitWall);
    var meleeGroup = this.zombiesMelee;
    var rangeGroup = this.zombiesRange;
    var bossGroup = this.zombiesBoss;
    var bottomGroup = this.bottomObjs;
    game.physics.arcade.overlap(this.bullets, this.zombiesMelee, function (bullet, zombie) {
        return bulletHitEnemy(game, bullet, zombie, meleeGroup, bottomGroup);
    }, null, null);
    game.physics.arcade.overlap(this.bullets, this.zombiesRange, function (bullet, zombie) {
        return bulletHitEnemy(game, bullet, zombie, rangeGroup, bottomGroup);
    }, null, null);
    game.physics.arcade.overlap(this.bullets, this.zombiesBoss, function (bullet, zombie) {
        return bulletHitEnemy(game, bullet, zombie, bossGroup, bottomGroup, function (zombie, zombieSpawn) {
            zombieSpawn.respawnTime = null;
            return winWinWin(game);
        });
    }, null, null);
    game.physics.arcade.overlap(this.player, this.gooPools, partial(gooPoolHitPlayer, game), null, null);
    game.physics.arcade.overlap(this.player, this.medicine, partial(takeMedicine, game), null, null);
    game.physics.arcade.overlap(this.player, this.masterGuns, takeMasterGun, null, null);
    if (game.gameState === PLAYING) {
        this.player.body.velocity.x = 0;
        this.player.body.velocity.y = 0;
        if (this.cursors.up.isDown && this.cursors.right.isDown) {
            playerMoveUpRight(this.player);
        } else if (this.cursors.down.isDown && this.cursors.right.isDown) {
            playerMoveDownRight(this.player);
        } else if (this.cursors.up.isDown && this.cursors.left.isDown) {
            playerMoveUpLeft(this.player);
        } else if (this.cursors.down.isDown && this.cursors.left.isDown) {
            playerMoveDownLeft(this.player);
        } else if (this.cursors.down.isDown) {
            playerMoveDown(this.player);
        } else if (this.cursors.up.isDown) {
            playerMoveUp(this.player);
        } else if (this.cursors.right.isDown) {
            playerMoveRight(this.player);
        } else if (this.cursors.left.isDown) {
            playerMoveLeft(this.player);
        } else {
            playerStop(this.player);
        };
        updatePlayer(this.player);
        updateZombiesMelee(game, this.zombiesMelee, this.player);
        updateZombiesRange(game, this.zombiesRange, this.player, this.gooPools);
        updateZombiesBoss(game, this.zombiesBoss, this.player);
        updateGooPools(game, this.gooPools);
        var _js5119 = this.spawns;
        var _js5121 = _js5119.length;
        for (var _js5120 = 0; _js5120 < _js5121; _js5120 += 1) {
            var spawn = _js5119[_js5120];
            updateSpawn(game, spawn);
        };
        var _js5122 = this.medicine.children;
        var _js5124 = _js5122.length;
        for (var _js5123 = 0; _js5123 < _js5124; _js5123 += 1) {
            var chickenLeg = _js5122[_js5123];
            updateMedicine(chickenLeg);
        };
    };
    return null;
},
                  shutdown : function (game) {
    return this.spawns = [];
}
                };
var winState = {  };
var loseState = {  };
function init() {
    var game = new Phaser.Game(1024, 768, Phaser.AUTO, 'game');
    game.state.add('boot', bootState);
    game.state.add('load', loadState);
    game.state.add('menu', menuState);
    game.state.add('play', playState);
    game.state.add('win', winState);
    game.state.add('lose', loseState);
    return game.state.start('boot');
};
